package yrpg.bamp.basedata.webapi;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.openapi.api.result.ApiSaveResult;
import kd.bos.openapi.api.result.BaseFilterItemData;
import kd.bos.openapi.api.result.BaseFilterResult;
import kd.bos.openapi.common.custom.annotation.ApiController;
import kd.bos.openapi.common.custom.annotation.ApiParam;
import kd.bos.openapi.common.custom.annotation.ApiPostMapping;
import kd.bos.openapi.common.result.CustomApiResult;
import kd.bos.openapi.common.result.OpenApiResult;
import kd.bos.openapi.common.util.OpenApiSdkUtil;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.bos.util.StringUtils;
import yrpg.bamp.basedata.common.ApiReqModel;
import yrpg.bamp.basedata.common.AssembleResponseUtil;

import javax.validation.Valid;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@ApiController(value="CommonBill",desc="统一url入口")
public class CostCenterApiController {
	//存放实际地址和接口入口的
	@ApiPostMapping(value="costCenterURLApiHandler")
	public CustomApiResult<Object> costCenterApiHandler(@Valid  @ApiParam("入口参数") ApiReqModel reqModel) {
		//获取入参
		String reqdata=reqModel.getData();
		JSONArray dataArray = JSONObject.parseArray(reqdata);
		// 新增（修改）、启用（解封）、禁用（封存） 入参
		JSONObject saveDataJson = new JSONObject();
		JSONObject freezeDataJson = new JSONObject();
		JSONObject unfreezeDataJson = new JSONObject();
		//解封时更新
		JSONObject unfreezeUpdateDataJson = new JSONObject();

		// 新增（修改）、启用（解封）、禁用（封存） data层参数
		JSONArray costcenterData = new JSONArray();
		JSONArray freezeNums = new JSONArray();
		JSONArray unfreezeNums = new JSONArray();
		//解封时更新
		JSONArray unfreezeData = new JSONArray();

		JSONObject freezeNumsJson = new JSONObject();
		JSONObject unfreezeNumsJson = new JSONObject();

		List<String> mainids = new ArrayList<String>();
		for(int i=0;i<dataArray.size();i++) {
			JSONObject jsonObject = dataArray.getJSONObject(i);
			String number = jsonObject.getString("yrpg_mainid");
			mainids.add(number);
		}

		//获取系统现有成本中心数据
		DynamicObjectCollection costcenters = QueryServiceHelper.query("bos_costcenter", "number,yrpg_mainid,enable", new QFilter[]{});
		Map<String,String> costcenterStatusMap = new HashMap<String,String>();
		Map<String,String> costcenterNumMap = new HashMap<String,String>();
		for (DynamicObject costcenter : costcenters){
			costcenterStatusMap.put(costcenter.getString("yrpg_mainid"),costcenter.getString("enable"));
			costcenterNumMap.put(costcenter.getString("number"),costcenter.getString("yrpg_mainid"));
		}
		//新增废弃数据，执行跳过，接口返回参数
		JSONArray newfreezeData = new JSONArray();
		JSONArray orgNumerrData = new JSONArray();

		//循环判断部门进入保存、封存、解封集合
		for(int i=0;i<dataArray.size();i++){
			JSONObject jsonObject = dataArray.getJSONObject(i);
			String number = jsonObject.getString("yrpg_mainid");
			boolean isfreeze = jsonObject.getBoolean("isfreeze");
			String accountorg_number = jsonObject.getString("accountorg_number");
			QFilter comFilter = new QFilter("yrpg_companynum", QCP.equals,accountorg_number);
			DynamicObject company = BusinessDataServiceHelper.loadSingleFromCache("", "id", new QFilter[]{comFilter});
			if(company==null){
				orgNumerrData.add(jsonObject);
				continue;
			}
			//根据入参是否封存，已经系统中状态判断
			if(costcenterStatusMap.get(number)==null&&isfreeze){
				newfreezeData.add(jsonObject);
				//禁用直接跳过
				continue;
			}
			//根据入参是否封存，已经系统中状态判断
			if(costcenterStatusMap.get(number)==null){
				//新增
				costcenterData.add(jsonObject);
			}else if(!isfreeze&&costcenterStatusMap.get(number).equals("1")){
				//更新
				costcenterData.add(jsonObject);
			}else if(costcenterStatusMap.get(number).equals("1")&&isfreeze){
				//禁用
				freezeNums.add(number);
			}else if(costcenterStatusMap.get(number).equals("0")&&!isfreeze){
				//启用更新
				unfreezeNums.add(number);
				unfreezeData.add(jsonObject);

			}
		}

		//返回值
		BaseFilterResult responseData = new BaseFilterResult();
		CustomApiResult finalResult =new CustomApiResult();
		//判断是否调用禁用启用
		boolean isfreeze = false;
		//调用禁用接口
		if(freezeNums.size()>0){
			isfreeze = true;
			freezeNumsJson.put("yrpg_mainids",freezeNums);
			freezeDataJson.put("data",freezeNumsJson);
			//调用接口
			OpenApiResult adminfreeze = OpenApiSdkUtil.invoke("/v2/yrpg/basedata/bos_costcenter/costcenterDisable", freezeDataJson, new HashMap<>());
			BaseFilterResult data = (BaseFilterResult)adminfreeze.getData();
			List<BaseFilterItemData> result = data.getResult();
			for(BaseFilterItemData item : result){
				String number = item.getNumber();
				if(!StringUtils.isEmpty(number)){
					item.setNumber(costcenterNumMap.get(number));
				}
			}
			responseData = data;
		}
		//调用解封接口
		if(unfreezeNums.size()>0){
			unfreezeNumsJson.put("yrpg_mainids",unfreezeNums);
			unfreezeDataJson.put("data",unfreezeNumsJson);
			//调用接口
			OpenApiResult unfreezeResult = OpenApiSdkUtil.invoke("/v2/yrpg/basedata/bos_costcenter/costcenterEnable", unfreezeDataJson, new HashMap<>());
			unfreezeUpdateDataJson.put("data",unfreezeData);
			//调用接口
			OpenApiResult adminsave = OpenApiSdkUtil.invoke("/v2/yrpg/basedata/bos_costcenter/costcenterSave", unfreezeUpdateDataJson, new HashMap<>());
			ApiSaveResult data = (ApiSaveResult)adminsave.getData();
			//根据保存更新操作返回值结构，将保存返回值组装
			AssembleResponseUtil.assembleResult(data,responseData,isfreeze);

		}
		//调用保存接口
		if(costcenterData.size()>0){
			saveDataJson.put("data",costcenterData);
			//调用接口
			OpenApiResult adminsave = OpenApiSdkUtil.invoke("/v2/yrpg/basedata/bos_costcenter/costcenterSave", saveDataJson, new HashMap<>());
			ApiSaveResult data = (ApiSaveResult)adminsave.getData();
			//根据保存更新操作返回值结构，将保存返回值组装
			AssembleResponseUtil.assembleResult(data,responseData,isfreeze);

		}
		if(newfreezeData.size()>0){
			AssembleResponseUtil.addfreezeResult(newfreezeData,responseData,true);
		}
		if(orgNumerrData.size()>0){
			AssembleResponseUtil.addfreezeResult(orgNumerrData,responseData,false);
		}


		//多类型接口 过滤默认为空
		responseData.setFilter("");
		finalResult.setData(responseData);
		return finalResult;
	}


}